VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cLogReports"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' This class holds a reference to the object obtained from PrintPreview.Events
' PrintPreview is a global object that is used by the PrintPreview controls to handle the printing and print preview tasks
' PrintPreview.Events is a PrinterExEvents object type that globally can raise print events.
' These events are the same that each control has, but global

Private WithEvents mPrinterEvents As PrinterExEvents
Attribute mPrinterEvents.VB_VarHelpID = -1

Private Sub Class_Initialize()
    'set the reference to PrintPreview.Events into mPrinterEvents
    Set mPrinterEvents = PrintPreview.Events
End Sub

' Use the ReportPrinted event to log into a file each report that is printed
Private Sub mPrinterEvents_ReportPrinted()
    Dim FFile As Long
    
    FFile = FreeFile
    Open App.Path & "\PrintedReportsLog.txt" For Append As #FFile
    Print #FFile, GetPrintedReportIdentification & vbTab & "Time: " & Now & vbTab & "Printer: " & Printer.DeviceName
    Close #FFile
End Sub

' Get an identification for the report.
' In this sample we used the ReportName property
' It could be also a global variable that you set for each report before showing the Print preview.
Private Function GetPrintedReportIdentification() As String
    If PrintPreview.ReportName <> "" Then
        GetPrintedReportIdentification = "ReportName: " & PrintPreview.ReportName
    ElseIf PrintPreview.ReportID <> "" Then
        GetPrintedReportIdentification = "ReportID: " & PrintPreview.ReportID
    ElseIf Not Screen.ActiveForm Is Nothing Then
        GetPrintedReportIdentification = "Form name: " & Screen.ActiveForm.Name
    Else
        GetPrintedReportIdentification = "Report without identification"
    End If
End Function
